Index: /branches/2012/dev_MERCATOR_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90
===================================================================
--- /branches/2012/dev_MERCATOR_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90	(revision 3582)
+++ /branches/2012/dev_MERCATOR_2012_rev3555/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90	(revision 3583)
@@ -8,5 +8,5 @@
    !!            3.0  !  2008-04  (NEMO team)  add in the reference version
    !!            3.3  !  2010-09  (D.Storkey and E.O'Dea)  bug fixes
-   !!            3.4  !  2011     (D. Storkey) rewrite in preparation for OBC-BDY merge
+   !!            3.4  !  2012-09  (G. Reffray and J. Chanut) New inputs + mods
    !!----------------------------------------------------------------------
 #if defined key_bdy
@@ -15,12 +15,6 @@
    !!----------------------------------------------------------------------
    !!   PUBLIC
-   !!      tide_init     : read of namelist and initialisation of tidal harmonics data
+   !!      bdytide_init     : read of namelist and initialisation of tidal harmonics data
    !!      tide_update   : calculation of tidal forcing at each timestep
-   !!   PRIVATE
-   !!      uvset         :\
-   !!      vday          : | Routines to correct tidal harmonics forcing for
-   !!      shpen         : | start time of integration
-   !!      ufset         : |
-   !!      vset          :/
    !!----------------------------------------------------------------------
    USE timing          ! Timing
@@ -34,4 +28,7 @@
    USE bdy_oce         ! ocean open boundary conditions
    USE daymod          ! calendar
+   USE wrk_nemo        ! Memory allocation
+   USE tideini
+!   USE tide_mod       ! Useless ??
    USE fldread, ONLY: fld_map
 
@@ -39,19 +36,18 @@
    PRIVATE
 
-   PUBLIC   tide_init     ! routine called in nemo_init
-   PUBLIC   tide_update   ! routine called in bdydyn
+   PUBLIC   bdytide_init     ! routine called in bdy_init
+   PUBLIC   bdytide_update   ! routine called in bdy_dta
 
    TYPE, PUBLIC ::   TIDES_DATA     !: Storage for external tidal harmonics data
-      INTEGER                                ::   ncpt       !: Actual number of tidal components
-      REAL(wp), POINTER, DIMENSION(:)        ::   speed      !: Phase speed of tidal constituent (deg/hr)
-      REAL(wp), POINTER, DIMENSION(:,:,:)    ::   ssh        !: Tidal constituents : SSH
-      REAL(wp), POINTER, DIMENSION(:,:,:)    ::   u          !: Tidal constituents : U
-      REAL(wp), POINTER, DIMENSION(:,:,:)    ::   v          !: Tidal constituents : V
+      REAL(wp), POINTER, DIMENSION(:,:,:)    ::   ssh0       !: Tidal constituents : SSH0 (read in file)
+      REAL(wp), POINTER, DIMENSION(:,:,:)    ::   u0         !: Tidal constituents : U0   (read in file)
+      REAL(wp), POINTER, DIMENSION(:,:,:)    ::   v0         !: Tidal constituents : V0   (read in file)
+      REAL(wp), POINTER, DIMENSION(:,:,:)    ::   ssh        !: Tidal constituents : SSH  (after nodal cor.)
+      REAL(wp), POINTER, DIMENSION(:,:,:)    ::   u          !: Tidal constituents : U    (after nodal cor.)
+      REAL(wp), POINTER, DIMENSION(:,:,:)    ::   v          !: Tidal constituents : V    (after nodal cor.)
    END TYPE TIDES_DATA
 
-   INTEGER, PUBLIC, PARAMETER                  ::   jptides_max = 15      !: Max number of tidal contituents
-
-   TYPE(TIDES_DATA), PUBLIC, DIMENSION(jp_bdy), TARGET ::   tides                 !: External tidal harmonics data
-   
+   TYPE(TIDES_DATA), PUBLIC, DIMENSION(jp_bdy), TARGET :: tides  !: External tidal harmonics data
+
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
@@ -61,7 +57,7 @@
 CONTAINS
 
-   SUBROUTINE tide_init
-      !!----------------------------------------------------------------------
-      !!                    ***  SUBROUTINE tide_init  ***
+   SUBROUTINE bdytide_init
+      !!----------------------------------------------------------------------
+      !!                    ***  SUBROUTINE bdytide_init  ***
       !!                     
       !! ** Purpose : - Read in namelist for tides and initialise external
@@ -71,28 +67,32 @@
       !! namelist variables
       !!-------------------
-      LOGICAL                                   ::   ln_tide_date !: =T correct tide phases and amplitude for model start date
-      CHARACTER(len=80)                         ::   filtide      !: Filename root for tidal input files
-      CHARACTER(len= 4), DIMENSION(jptides_max) ::   tide_cpt     !: Names of tidal components used.
-      REAL(wp),          DIMENSION(jptides_max) ::   tide_speed   !: Phase speed of tidal constituent (deg/hr)
+      CHARACTER(len=80)                         ::   filtide             !: Filename root for tidal input files
+      LOGICAL                                   ::   ln_bdytide_2ddta    !: If true, read 2d harmonic data
+      LOGICAL                                   ::   ln_bdytide_conj     !: If true, assume complex conjugate tidal data
       !!
-      INTEGER, DIMENSION(jptides_max)           ::   nindx              !: index of pre-set tidal components
-      INTEGER                                   ::   ib_bdy, itide, ib  !: dummy loop indices
+      INTEGER                                   ::   ib_bdy, itide, ib   !: dummy loop indices
+      INTEGER                                   ::   ii, ij              !: dummy loop indices
       INTEGER                                   ::   inum, igrd
-      INTEGER, DIMENSION(3)                     ::   ilen0              !: length of boundary data (from OBC arrays)
-      CHARACTER(len=80)                         ::   clfile             !: full file name for tidal input file 
-      REAL(wp)                                  ::   z_arg, z_atde, z_btde, z1t, z2t           
-      REAL(wp),DIMENSION(jptides_max)           ::   z_vplu, z_ftc
-      REAL(wp),ALLOCATABLE, DIMENSION(:,:,:)    ::   dta_read           !: work space to read in tidal harmonics data
+      INTEGER, DIMENSION(3)                     ::   ilen0       !: length of boundary data (from OBC arrays)
+      INTEGER, POINTER, DIMENSION(:)            ::   nblen, nblenrim     ! short cuts
+      CHARACTER(len=80)                         ::   clfile              !: full file name for tidal input file 
+      REAL(wp),ALLOCATABLE, DIMENSION(:,:,:)    ::   dta_read            !: work space to read in tidal harmonics data
+      REAL(wp), POINTER, DIMENSION(:,:)         ::   ztr, zti            !:  "     "    "   "   "   "        "      " 
       !!
-      TYPE(TIDES_DATA),  POINTER                ::   td                 !: local short cut   
+      TYPE(TIDES_DATA),  POINTER                ::   td                  !: local short cut   
       !!
-      NAMELIST/nambdy_tide/ln_tide_date, filtide, tide_cpt, tide_speed
-      !!----------------------------------------------------------------------
-
-      IF( nn_timing == 1 ) CALL timing_start('tide_init')
-
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) 'tide_init : initialization of tidal harmonic forcing at open boundaries'
-      IF(lwp) WRITE(numout,*) '~~~~~~~~~'
+      NAMELIST/nambdy_tide/filtide, ln_bdytide_2ddta, ln_bdytide_conj
+      !!----------------------------------------------------------------------
+
+      IF( nn_timing == 1 ) CALL timing_start('bdytide_init')
+
+      IF (nb_bdy>0) THEN
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'bdytide_init : initialization of tidal harmonic forcing at open boundaries'
+         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~'
+      ENDIF
+
+      ln_bdytide_2ddta = .FALSE.
+      ln_bdytide_conj  = .FALSE.
 
       REWIND(numnam)
@@ -101,166 +101,154 @@
 
             td => tides(ib_bdy)
+            nblen => idx_bdy(ib_bdy)%nblen
+            nblenrim => idx_bdy(ib_bdy)%nblenrim
 
             ! Namelist nambdy_tide : tidal harmonic forcing at open boundaries
-            ln_tide_date = .false.
             filtide(:) = ''
-            tide_speed(:) = 0.0
-            tide_cpt(:) = ''
 
             ! Don't REWIND here - may need to read more than one of these namelists.
             READ  ( numnam, nambdy_tide )
-            !                                               ! Count number of components specified
-            td%ncpt = 0
-            DO itide = 1, jptides_max
-              IF( tide_cpt(itide) /= '' ) THEN
-                 td%ncpt = td%ncpt + 1
-              ENDIF
-            END DO
-
-            ! Fill in phase speeds from namelist
-            ALLOCATE( td%speed(td%ncpt) )
-            td%speed = tide_speed(1:td%ncpt)
-
-            ! Find constituents in standard list
-            DO itide = 1, td%ncpt
-               nindx(itide) = 0
-               IF( TRIM( tide_cpt(itide) ) == 'Q1'  )   nindx(itide) =  1
-               IF( TRIM( tide_cpt(itide) ) == 'O1'  )   nindx(itide) =  2
-               IF( TRIM( tide_cpt(itide) ) == 'P1'  )   nindx(itide) =  3
-               IF( TRIM( tide_cpt(itide) ) == 'S1'  )   nindx(itide) =  4
-               IF( TRIM( tide_cpt(itide) ) == 'K1'  )   nindx(itide) =  5
-               IF( TRIM( tide_cpt(itide) ) == '2N2' )   nindx(itide) =  6
-               IF( TRIM( tide_cpt(itide) ) == 'MU2' )   nindx(itide) =  7
-               IF( TRIM( tide_cpt(itide) ) == 'N2'  )   nindx(itide) =  8
-               IF( TRIM( tide_cpt(itide) ) == 'NU2' )   nindx(itide) =  9
-               IF( TRIM( tide_cpt(itide) ) == 'M2'  )   nindx(itide) = 10
-               IF( TRIM( tide_cpt(itide) ) == 'L2'  )   nindx(itide) = 11
-               IF( TRIM( tide_cpt(itide) ) == 'T2'  )   nindx(itide) = 12
-               IF( TRIM( tide_cpt(itide) ) == 'S2'  )   nindx(itide) = 13
-               IF( TRIM( tide_cpt(itide) ) == 'K2'  )   nindx(itide) = 14
-               IF( TRIM( tide_cpt(itide) ) == 'M4'  )   nindx(itide) = 15
-               IF( nindx(itide) == 0  .AND. lwp ) THEN
-                  WRITE(ctmp1,*) 'constitunent', itide,':', tide_cpt(itide), 'not in standard list'
-                  CALL ctl_warn( ctmp1 )
-               ENDIF
-            END DO
             !                                               ! Parameter control and print
-            IF( td%ncpt < 1 ) THEN 
-               CALL ctl_stop( '          Did not find any tidal components in namelist nambdy_tide' )
+            IF(lwp) WRITE(numout,*) '  '
+            IF(lwp) WRITE(numout,*) '          Namelist nambdy_tide : tidal harmonic forcing at open boundaries'
+            IF(lwp) WRITE(numout,*) '             read tidal data in 2d files: ', ln_bdytide_2ddta
+            IF(lwp) WRITE(numout,*) '             assume complex conjugate   : ', ln_bdytide_conj
+            IF(lwp) WRITE(numout,*) '             Number of tidal components to read: ', nb_harmo
+            IF(lwp) THEN 
+                    WRITE(numout,*) '             Tidal cpt name    -     Phase speed (deg/hr)'            
+               DO itide = 1, nb_harmo
+                  WRITE(numout,*)  '             ', Wave(ntide(itide))%cname_tide, omega_tide(itide)   
+               END DO
+            ENDIF 
+            IF(lwp) WRITE(numout,*) ' '
+
+            ! Allocate space for tidal harmonics data - get size from OBC data arrays
+            ! -----------------------------------------------------------------------
+
+            ! JC: If FRS scheme is used, we assume that tidal is needed over the whole
+            ! relaxation area      
+            IF( nn_dyn2d(ib_bdy) .eq. jp_frs ) THEN
+               ilen0(:)=nblen(:)
             ELSE
-               IF(lwp) WRITE(numout,*) '          Namelist nambdy_tide : tidal harmonic forcing at open boundaries'
-               IF(lwp) WRITE(numout,*) '             tidal components specified ', td%ncpt
-               IF(lwp) WRITE(numout,*) '                ', tide_cpt(1:td%ncpt)
-               IF(lwp) WRITE(numout,*) '             associated phase speeds (deg/hr) : '
-               IF(lwp) WRITE(numout,*) '                ', tide_speed(1:td%ncpt)
+               ilen0(:)=nblenrim(:)
             ENDIF
 
-
-            ! Allocate space for tidal harmonics data - 
-            ! get size from OBC data arrays
-            ! ---------------------------------------
-
-            ilen0(1) = SIZE( dta_bdy(ib_bdy)%ssh ) 
-            ALLOCATE( td%ssh( ilen0(1), td%ncpt, 2 ) )
-
-            ilen0(2) = SIZE( dta_bdy(ib_bdy)%u2d ) 
-            ALLOCATE( td%u( ilen0(2), td%ncpt, 2 ) )
-
-            ilen0(3) = SIZE( dta_bdy(ib_bdy)%v2d ) 
-            ALLOCATE( td%v( ilen0(3), td%ncpt, 2 ) )
-
-            ALLOCATE( dta_read( MAXVAL(ilen0), 1, 1 ) )
-
-
-            ! Open files and read in tidal forcing data
-            ! -----------------------------------------
-
-            DO itide = 1, td%ncpt
-               !                                                              ! SSH fields
-               clfile = TRIM(filtide)//TRIM(tide_cpt(itide))//'_grid_T.nc'
-               IF(lwp) WRITE(numout,*) 'Reading data from file ', clfile
-               CALL iom_open( clfile, inum )
-               CALL fld_map( inum, 'z1' , dta_read(1:ilen0(1),1:1,1:1) , 1, idx_bdy(ib_bdy)%nbmap(:,1) )
-               td%ssh(:,itide,1) = dta_read(1:ilen0(1),1,1)
-               CALL fld_map( inum, 'z2' , dta_read(1:ilen0(1),1:1,1:1) , 1, idx_bdy(ib_bdy)%nbmap(:,1) )
-               td%ssh(:,itide,2) = dta_read(1:ilen0(1),1,1)
+            ALLOCATE( td%ssh0( ilen0(1), nb_harmo, 2 ) )
+            ALLOCATE( td%ssh ( ilen0(1), nb_harmo, 2 ) )
+
+            ALLOCATE( td%u0( ilen0(2), nb_harmo, 2 ) )
+            ALLOCATE( td%u ( ilen0(2), nb_harmo, 2 ) )
+
+            ALLOCATE( td%v0( ilen0(3), nb_harmo, 2 ) )
+            ALLOCATE( td%v ( ilen0(3), nb_harmo, 2 ) )
+
+            td%ssh0(:,:,:) = 0.e0
+            td%ssh(:,:,:) = 0.e0
+            td%u0(:,:,:) = 0.e0
+            td%u(:,:,:) = 0.e0
+            td%v0(:,:,:) = 0.e0
+            td%v(:,:,:) = 0.e0
+
+            IF (ln_bdytide_2ddta) THEN
+               ! It is assumed that each data file contains all complex harmonic amplitudes
+               ! given on the data domain (ie global, jpidta x jpjdta)
+               !
+               CALL wrk_alloc( jpi, jpj, zti, ztr )
+               !
+               ! SSH fields
+               clfile = TRIM(filtide)//'_grid_T.nc'
+               CALL iom_open (clfile , inum ) 
+               igrd = 1                       ! Everything is at T-points here
+               DO itide = 1, nb_harmo
+                  CALL iom_get  ( inum, jpdom_data, TRIM(Wave(ntide(itide))%cname_tide)//'_z1', ztr(:,:) )
+                  CALL iom_get  ( inum, jpdom_data, TRIM(Wave(ntide(itide))%cname_tide)//'_z2', zti(:,:) ) 
+                  DO ib = 1, ilen0(igrd)
+                     ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
+                     ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                     td%ssh0(ib,itide,1) = ztr(ii,ij)
+                     td%ssh0(ib,itide,2) = zti(ii,ij)
+                  END DO
+               END DO 
                CALL iom_close( inum )
-               !                                                              ! U fields
-               clfile = TRIM(filtide)//TRIM(tide_cpt(itide))//'_grid_U.nc'
-               IF(lwp) WRITE(numout,*) 'Reading data from file ', clfile
-               CALL iom_open( clfile, inum )
-               CALL fld_map( inum, 'u1' , dta_read(1:ilen0(2),1:1,1:1) , 1, idx_bdy(ib_bdy)%nbmap(:,2) )
-               td%u(:,itide,1) = dta_read(1:ilen0(2),1,1)
-               CALL fld_map( inum, 'u2' , dta_read(1:ilen0(2),1:1,1:1) , 1, idx_bdy(ib_bdy)%nbmap(:,2) )
-               td%u(:,itide,2) = dta_read(1:ilen0(2),1,1)
+               !
+               ! U fields
+               clfile = TRIM(filtide)//'_grid_U.nc'
+               CALL iom_open (clfile , inum ) 
+               igrd = 2                       ! Everything is at U-points here
+               DO itide = 1, nb_harmo
+                  CALL iom_get  ( inum, jpdom_data, TRIM(Wave(ntide(itide))%cname_tide)//'_u1', ztr(:,:) )
+                  CALL iom_get  ( inum, jpdom_data, TRIM(Wave(ntide(itide))%cname_tide)//'_u2', zti(:,:) )
+                  DO ib = 1, ilen0(igrd)
+                     ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
+                     ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                     td%u0(ib,itide,1) = ztr(ii,ij)
+                     td%u0(ib,itide,2) = zti(ii,ij)
+                  END DO
+               END DO
                CALL iom_close( inum )
-               !                                                              ! V fields
-               clfile = TRIM(filtide)//TRIM(tide_cpt(itide))//'_grid_V.nc'
-               IF(lwp) WRITE(numout,*) 'Reading data from file ', clfile
-               CALL iom_open( clfile, inum )
-               CALL fld_map( inum, 'v1' , dta_read(1:ilen0(3),1:1,1:1) , 1, idx_bdy(ib_bdy)%nbmap(:,3) )
-               td%v(:,itide,1) = dta_read(1:ilen0(3),1,1)
-               CALL fld_map( inum, 'v2' , dta_read(1:ilen0(3),1:1,1:1) , 1, idx_bdy(ib_bdy)%nbmap(:,3) )
-               td%v(:,itide,2) = dta_read(1:ilen0(3),1,1)
+               !
+               ! V fields
+               clfile = TRIM(filtide)//'_grid_V.nc'
+               CALL iom_open (clfile , inum ) 
+               igrd = 3                       ! Everything is at V-points here
+               DO itide = 1, nb_harmo
+                  CALL iom_get  ( inum, jpdom_data, TRIM(Wave(ntide(itide))%cname_tide)//'_v1', ztr(:,:) )
+                  CALL iom_get  ( inum, jpdom_data, TRIM(Wave(ntide(itide))%cname_tide)//'_v2', zti(:,:) )
+                  DO ib = 1, ilen0(igrd)
+                     ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
+                     ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                     td%v0(ib,itide,1) = ztr(ii,ij)
+                     td%v0(ib,itide,2) = zti(ii,ij)
+                  END DO
+               END DO  
                CALL iom_close( inum )
                !
-            END DO ! end loop on tidal components
-
-            IF( ln_tide_date ) THEN      ! correct for date factors
-
-!! used nmonth, nyear and nday from daymod....
-               ! Calculate date corrects for 15 standard consituents
-               ! This is the initialisation step, so nday, nmonth, nyear are the 
-               ! initial date/time of the integration.
-                 print *, nday,nmonth,nyear
-                 nyear  = int(ndate0 / 10000  )                          ! initial year
-                 nmonth = int((ndate0 - nyear * 10000 ) / 100 )          ! initial month
-                 nday   = int(ndate0 - nyear * 10000 - nmonth * 100)
-
-               CALL uvset( 0, nday, nmonth, nyear, z_ftc, z_vplu )
-
-               IF(lwp) WRITE(numout,*) 'Correcting tide for date:', nday, nmonth, nyear
-
-               DO itide = 1, td%ncpt       ! loop on tidal components
+               CALL wrk_dealloc( jpi, jpj, ztr, zti ) 
+               !
+            ELSE            
+               !
+               ! Read tidal data only on bdy segments
+               ! 
+               ALLOCATE( dta_read( MAXVAL(ilen0(1:3)), 1, 1 ) )
+
+               ! Open files and read in tidal forcing data
+               ! -----------------------------------------
+
+               DO itide = 1, nb_harmo
+                  !                                                              ! SSH fields
+                  clfile = TRIM(filtide)//TRIM(Wave(ntide(itide))%cname_tide)//'_grid_T.nc'
+                  CALL iom_open( clfile, inum )
+                  CALL fld_map( inum, 'z1' , dta_read(1:ilen0(1),1:1,1:1) , 1, idx_bdy(ib_bdy)%nbmap(:,1) )
+                  td%ssh0(:,itide,1) = dta_read(1:ilen0(1),1,1)
+                  CALL fld_map( inum, 'z2' , dta_read(1:ilen0(1),1:1,1:1) , 1, idx_bdy(ib_bdy)%nbmap(:,1) )
+                  td%ssh0(:,itide,2) = dta_read(1:ilen0(1),1,1)
+                  CALL iom_close( inum )
+                  !                                                              ! U fields
+                  clfile = TRIM(filtide)//TRIM(Wave(ntide(itide))%cname_tide)//'_grid_U.nc'
+                  CALL iom_open( clfile, inum )
+                  CALL fld_map( inum, 'u1' , dta_read(1:ilen0(2),1:1,1:1) , 1, idx_bdy(ib_bdy)%nbmap(:,2) )
+                  td%u0(:,itide,1) = dta_read(1:ilen0(2),1,1)
+                  CALL fld_map( inum, 'u2' , dta_read(1:ilen0(2),1:1,1:1) , 1, idx_bdy(ib_bdy)%nbmap(:,2) )
+                  td%u0(:,itide,2) = dta_read(1:ilen0(2),1,1)
+                  CALL iom_close( inum )
+                  !                                                              ! V fields
+                  clfile = TRIM(filtide)//TRIM(Wave(ntide(itide))%cname_tide)//'_grid_V.nc'
+                  CALL iom_open( clfile, inum )
+                  CALL fld_map( inum, 'v1' , dta_read(1:ilen0(3),1:1,1:1) , 1, idx_bdy(ib_bdy)%nbmap(:,3) )
+                  td%v0(:,itide,1) = dta_read(1:ilen0(3),1,1)
+                  CALL fld_map( inum, 'v2' , dta_read(1:ilen0(3),1:1,1:1) , 1, idx_bdy(ib_bdy)%nbmap(:,3) )
+                  td%v0(:,itide,2) = dta_read(1:ilen0(3),1,1)
+                  CALL iom_close( inum )
                   !
-                  IF( nindx(itide) /= 0 ) THEN
-!!gm use rpi  and rad global variable  
-                     z_arg = 3.14159265d0 * z_vplu(nindx(itide)) / 180.0d0
-                     z_atde=z_ftc(nindx(itide))*cos(z_arg)
-                     z_btde=z_ftc(nindx(itide))*sin(z_arg)
-                     IF(lwp) WRITE(numout,'(2i5,8f10.6)') itide, nindx(itide), td%speed(itide),   &
-                        &                                 z_ftc(nindx(itide)), z_vplu(nindx(itide))
-                  ELSE
-                     z_atde = 1.0_wp
-                     z_btde = 0.0_wp
-                  ENDIF
-                  !                                         !  elevation         
-                  igrd = 1
-                  DO ib = 1, ilen0(igrd)                
-                     z1t = z_atde * td%ssh(ib,itide,1) + z_btde * td%ssh(ib,itide,2)
-                     z2t = z_atde * td%ssh(ib,itide,2) - z_btde * td%ssh(ib,itide,1)
-                     td%ssh(ib,itide,1) = z1t
-                     td%ssh(ib,itide,2) = z2t
-                  END DO
-                  !                                         !  u       
-                  igrd = 2
-                  DO ib = 1, ilen0(igrd)                
-                     z1t = z_atde * td%u(ib,itide,1) + z_btde * td%u(ib,itide,2)
-                     z2t = z_atde * td%u(ib,itide,2) - z_btde * td%u(ib,itide,1)
-                     td%u(ib,itide,1) = z1t
-                     td%u(ib,itide,2) = z2t
-                  END DO
-                  !                                         !  v       
-                  igrd = 3
-                  DO ib = 1, ilen0(igrd)                
-                     z1t = z_atde * td%v(ib,itide,1) + z_btde * td%v(ib,itide,2)
-                     z2t = z_atde * td%v(ib,itide,2) - z_btde * td%v(ib,itide,1)
-                     td%v(ib,itide,1) = z1t
-                     td%v(ib,itide,2) = z2t
-                  END DO
-                  !
-               END DO   ! end loop on tidal components
-               !
-            ENDIF ! date correction
+               END DO ! end loop on tidal components
+               !
+               DEALLOCATE( dta_read )
+            ENDIF ! ln_bdytide_2ddta=.true.
+            !
+            IF ( ln_bdytide_conj ) THEN ! assume complex conjugate in data files
+               td%ssh0(:,:,2) = - td%ssh0(:,:,2)
+               td%u0  (:,:,2) = - td%u0  (:,:,2)
+               td%v0  (:,:,2) = - td%v0  (:,:,2)
+            ENDIF
             !
          ENDIF ! nn_dyn2d_dta(ib_bdy) .ge. 2
@@ -268,36 +256,59 @@
       END DO ! loop on ib_bdy
 
-      IF( nn_timing == 1 ) CALL timing_stop('tide_init')
-
-   END SUBROUTINE tide_init
-
-
-   SUBROUTINE tide_update ( kt, idx, dta, td, jit, time_offset )
-      !!----------------------------------------------------------------------
-      !!                 ***  SUBROUTINE tide_update  ***
+      IF( nn_timing == 1 ) CALL timing_stop('bdytide_init')
+
+   END SUBROUTINE bdytide_init
+
+   SUBROUTINE bdytide_update ( kt, idx, dta, td, jit, time_offset )
+      !!----------------------------------------------------------------------
+      !!                 ***  SUBROUTINE bdytide_update  ***
       !!                
       !! ** Purpose : - Add tidal forcing to ssh, u2d and v2d OBC data arrays. 
       !!                
       !!----------------------------------------------------------------------
-      INTEGER, INTENT( in )          ::   kt      ! Main timestep counter
-!!gm doctor jit ==> kit
-      TYPE(OBC_INDEX), INTENT( in )  ::   idx     ! OBC indices
-      TYPE(OBC_DATA),  INTENT(inout) ::   dta     ! OBC external data
-      TYPE(TIDES_DATA),INTENT( in )  ::   td      ! tidal harmonics data
-      INTEGER,INTENT(in),OPTIONAL    ::   jit     ! Barotropic timestep counter (for timesplitting option)
-      INTEGER,INTENT( in ), OPTIONAL ::   time_offset  ! time offset in units of timesteps. NB. if jit
-                                                       ! is present then units = subcycle timesteps.
-                                                       ! time_offset = 0 => get data at "now" time level
-                                                       ! time_offset = -1 => get data at "before" time level
-                                                       ! time_offset = +1 => get data at "after" time level
-                                                       ! etc.
+      INTEGER, INTENT( in )            ::   kt          ! Main timestep counter
+      TYPE(OBC_INDEX), INTENT( in )    ::   idx         ! OBC indices
+      TYPE(OBC_DATA),  INTENT(inout)   ::   dta         ! OBC external data
+      TYPE(TIDES_DATA),INTENT( inout ) ::   td          ! tidal harmonics data
+      INTEGER,INTENT(in),OPTIONAL      ::   jit         ! Barotropic timestep counter (for timesplitting option)
+      INTEGER,INTENT( in ), OPTIONAL   ::   time_offset ! time offset in units of timesteps. NB. if jit
+                                                        ! is present then units = subcycle timesteps.
+                                                        ! time_offset = 0  => get data at "now"    time level
+                                                        ! time_offset = -1 => get data at "before" time level
+                                                        ! time_offset = +1 => get data at "after"  time level
+                                                        ! etc.
       !!
-      INTEGER                          :: itide, igrd, ib      ! dummy loop indices
-      INTEGER                          :: time_add             ! time offset in units of timesteps
-      REAL(wp)                         :: z_arg, z_sarg      
-      REAL(wp), DIMENSION(jptides_max) :: z_sist, z_cost
-      !!----------------------------------------------------------------------
-
-      IF( nn_timing == 1 ) CALL timing_start('tide_update')
+      INTEGER, DIMENSION(3)            ::   ilen0       !: length of boundary data (from OBC arrays)
+      INTEGER                          :: itide, igrd, ib   ! dummy loop indices
+      INTEGER                          :: time_add          ! time offset in units of timesteps
+      REAL(wp)                         :: z_arg, z_sarg, zflag, zramp      
+      REAL(wp), DIMENSION(jpmax_harmo) :: z_sist, z_cost
+      !!----------------------------------------------------------------------
+
+      IF( nn_timing == 1 ) CALL timing_start('bdytide_update')
+
+      ilen0(1) =  SIZE(td%ssh(:,1,1))
+      ilen0(2) =  SIZE(td%u(:,1,1))
+      ilen0(3) =  SIZE(td%v(:,1,1))
+
+      zflag=1
+      IF ( PRESENT(jit) ) THEN
+        IF ( jit /= 1 ) zflag=0
+      ENDIF
+
+      IF ( nsec_day == NINT(0.5 * rdttra(1)) .AND. zflag==1 ) THEN
+        !
+        kt_tide = kt
+        !
+        IF(lwp) THEN
+           WRITE(numout,*)
+           WRITE(numout,*) 'bdytide_update : (re)Initialization of the tidal bdy forcing at kt=',kt
+           WRITE(numout,*) '~~~~~~~~~~~~~~ '
+        ENDIF
+        !
+        CALL tide_init_elevation ( idx, td )
+        CALL tide_init_velocities( idx, td )
+        !
+      ENDIF 
 
       time_add = 0
